/*
** udp.c - moves fury frames over UDP .. MESSY and LAME! beat that! HA!
**
** Keith Zaback (krz@wcug.wwu.edu) Sep 98
*/

#include "ipxfury.h"
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <time.h>
#include <errno.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>

/* debugging things */
#define LOG_PACKETS		0		/* should we log packets */
#define SIMULATE_CRAP		0		/* a crap network */
#define PACKET_LOSS_CHANCE	20		/* a percent */
#define SHOW_UDP_WRITE		0
#define SHOW_FORWARDING		0

/* types */

#define BCAST_TYPE_IPX		1		/* an IPX packet with broadcast dest */
#define BCAST_TYPE_UDP		2		/* a UDP packet that needs to go to everyone */

typedef struct stUDP_BCAST {
	int			type;		/* type of cast */
	INTERFACE		*udp;		/* us */
	union { 
		struct {
			BYTE			*i_ipxframe;	/* the FULL ipx frame to send to everyone */
		} i;
		struct {
			BYTE			*u_data;
			int			u_len;
		} u;
	} data;
	IPADDR_ENTRY		*sender;	/* who sent this (the ipx frame) */
	IPADDR_ENTRY		*src;		/* ipx src hwaddr -> ip */
} UDP_BCAST;

/* globals */
BYTE			udp_buffer[FURY_UDP_RECV_BUF_SIZE];
UDP_BCAST		broadcast;
int			active_ips;
extern GLOBALS		ifg;
extern unsigned char	broadcast_addr[6];


/* protos */
void		udp_sendto_all(int num, IPADDR_ENTRY *entry);
void		udp_send_ip_change(INTERFACE *udp, IPADDR_ENTRY *to, HWIP_ENTRY *hwip);
int		udp_new_ip_entry(INTERFACE *udp, IPADDR_ENTRY *ipaddr_entry);
int		udp_change_hwip(INTERFACE *udp, IP_CHANGE *change);
int		udp_remove_ip(INTERFACE *udp, IPADDR_ENTRY *ip);
int		udp_remove_mappings(HWIP_ENTRY *entry);
int		udp_sendto(INTERFACE *udp, IPADDR_ENTRY *ip, void *buffer, int len);
void		udp_show_options(int opt);
void		udp_send_term_reqs(int num, IPADDR_ENTRY *entry);
int		udp_remove_losers(IPADDR_ENTRY *entry);
void		udp_accept_connect(BYTE *data, int data_len, IPADDR_ENTRY *ipaddr);
int		udp_connect_reply(INTERFACE *udp, IPADDR_ENTRY *ipaddr);
int		udp_build_hwaddr_list(INTERFACE *udp, BYTE *data, int data_len);
void		udp_read_hwaddr_list(INTERFACE *udp, BYTE *data, int data_len, IPADDR_ENTRY *ipaddr_entry);
int		udp_keepalive_check(int num, IPADDR_ENTRY *entry);
void		udp_lookup_host(IPADDR_ENTRY *ipaddr_entry);


/*
**	UDP_LOOKUP_HOST -
*/
void udp_lookup_host(IPADDR_ENTRY *ipaddr_entry)
{
	struct hostent	*hp;
	
	/* build hostname from IP */
	strcpy(ipaddr_entry->hostname, inet_ntoa(ipaddr_entry->addr));

	/* look this joker up.. */
	ifg.alarm = 0;
	alarm(FURY_HOST_LOOKUP_WAIT);
	hp = gethostbyaddr((char *)&ipaddr_entry->addr, sizeof(struct in_addr), AF_INET);
	alarm(0);
	
	/* did we really get something */
	if( ifg.alarm == 0x00 ) {
		/* ok.. is it valid */
		if( NULL != hp ) {
			/* copy hostname */
			strncpy(ipaddr_entry->hostname, hp->h_name, FURY_HOSTNAME_MAX-1);
			ipaddr_entry->hostname[FURY_HOSTNAME_MAX-1] = 0x00;
		} 
	} 

	/* done */
	
}


/*
**	UDP_BUILD_HWADDR_LIST -
*/
int udp_build_hwaddr_list(INTERFACE *udp, BYTE *data, int data_len)
{
	HWADDR_ENTRY	*entry;
	HASHTRAV	trav;
	int		len;
	
	len = 0;
	
	/* attach our non-udp hardware addresses */
	entry = hash_start_trav(&ifg.hwaddr_table, &trav);
	while( entry != NULL ) {
		/* add it to the buffer if there is room */
		if( data_len >= 6 ) {
			/* there is room -- do we really want to add it? */
			if( (entry->interface != udp) && (entry->interface != NULL) ) {
				memcpy(data, entry->hwaddr, 6);
				data += 6;
				len += 6;
			}
			
			/* reduce len */
			data_len -= 6;
			
			/* get next entry */
			entry = hash_next_trav(&trav);
		} else {
			/* sent enough! */
			entry = NULL;
		}
	}
	
	/* done */
	return(len);
}


/*
**	UDP_READ_HWADDR_READ -
*/
void udp_read_hwaddr_list(INTERFACE *udp, BYTE *data, int data_len, IPADDR_ENTRY *ipaddr_entry)
{
	HWADDR_ENTRY	hwaddr_search, *hwaddr_entry;
	HWIP_ENTRY	hwip_search, *hwip_entry;
	
	/* clean them */
	memset(&hwaddr_search, 0x00, sizeof(HWADDR_ENTRY));
	memset(&hwip_search, 0x00, sizeof(HWIP_ENTRY));
	
	/* while we have data */
	while( data_len > 0 ) {
		if( data_len >= 6 ) {
			/* show it */
			notice("      %s\n", print_ether_addr(data));
			
			/* do we have it? */
			memcpy(hwaddr_search.hwaddr, data, 6);
			hwaddr_entry = hash_get(&ifg.hwaddr_table, &hwaddr_search);
			if( hwaddr_entry == NULL ) {
				/* add it -- fill out the interface */
				hwaddr_search.interface = udp;
				hwaddr_entry = hash_insert(&ifg.hwaddr_table, &hwaddr_search);
				if( hwaddr_entry == NULL ) {
					errormsg(0, "udp_read_list", "Could not add hwaddr to table!\n");
					return;
				}
				notice("New address discovered  %s -> %s\n", print_ether_addr(data), udp->name);

			} else {
				/* fix interface */
				hwaddr_entry->interface = udp;
			}
			
			/* now make a hw_to_ip entry */
			memcpy(hwip_search.hwaddr, data, 6);
			hwip_entry = hash_get(&udp->data.u.u_hw_to_ip, &hwip_search);
			if( hwip_entry == NULL ) {
				/* add it -- fill out the IP */
				hwip_search.ip = ipaddr_entry;
				hwip_entry = hash_insert(&udp->data.u.u_hw_to_ip, &hwip_search);	
				if( hwip_entry == NULL ) {
					errormsg(0, "udp_read_list", "Could not make HW <-> IP mapping!\n");
					return;
				}
				
				/* info */
				notice("[udp] Adding mapping: %s <-> %s:%d\n", print_ether_addr(data), hwip_entry->ip->hostname, hwip_entry->ip->port);
			} else {
				/* fix the ip addr entry */
				hwip_entry->ip = ipaddr_entry;
			}
		}
		
		/* move ptrs */
		data		+= 6;
		data_len	-= 6;
	}
	
	/* done */
	return;
}


/*
**	UDP_ACCEPT_CONREPLY - 
*/
void udp_accept_conreply(INTERFACE *udp, BYTE *data, int data_len, IPADDR_ENTRY *ipaddr_entry)
{
	VER_OPT_INFO	*veropt;
		
	/* un-remove them */
	ipaddr_entry->removed = 0;
	
	/* cache flush */
	hdrcache_flush(&ipaddr_entry->send_hdrcache);
	hdrcache_flush(&ipaddr_entry->recv_hdrcache);
				
	notice("[udp] Connected to %s:%d  Version: ", ipaddr_entry->hostname, ipaddr_entry->port);
	if( data_len > 0 ) {
		/* version info */
		veropt = (VER_OPT_INFO *)data;
		notice("%d.%d.%d\n[udp] Options: ", ntohl(veropt->major), ntohl(veropt->minor), ntohl(veropt->build));
		udp_show_options(ntohl(veropt->options));
		
		/* save info */
		ipaddr_entry->options	= ntohl(veropt->options);
		ipaddr_entry->v_major	= ntohl(veropt->major);
		ipaddr_entry->v_minor	= ntohl(veropt->minor);
		ipaddr_entry->v_build	= ntohl(veropt->build);
		
		/* notice */
		notice("[udp] Local Hardware Addresses:\n");
		
		/* read hardware addresses */
		udp_read_hwaddr_list(udp, (data + sizeof(VER_OPT_INFO)), (data_len - sizeof(VER_OPT_INFO)), ipaddr_entry);				
		
	} else {
		/* nothing */
		notice("SUPER-OLD!\n");
	}

}


/*
**	UDP_ACCEPT_CONNECTION
*/
void udp_accept_connection(INTERFACE *udp, BYTE *data, int data_len, IPADDR_ENTRY *ipaddr_entry)
{
	VER_OPT_INFO	*veropt;

	/* un-remove them */
	ipaddr_entry->removed = 0;
	
	/* flush their hdrcache */
	hdrcache_flush(&ipaddr_entry->send_hdrcache);
	hdrcache_flush(&ipaddr_entry->recv_hdrcache);
	
	/* notice */	
	notice("[udp] Connection from %s:%d  Version: ", ipaddr_entry->hostname, ipaddr_entry->port);
	
	/* are they using version/options info? */
	if( data_len > 0 ) {
		/* get version/options info */
		veropt = (VER_OPT_INFO *)data;
		notice("%d.%d.%d\n[udp] Options: ", ntohl(veropt->major), ntohl(veropt->minor), ntohl(veropt->build));
		udp_show_options(ntohl(veropt->options));	
		
		/* set options */
		ipaddr_entry->options	= ntohl(veropt->options);
		ipaddr_entry->v_major	= ntohl(veropt->major);
		ipaddr_entry->v_minor	= ntohl(veropt->minor);
		ipaddr_entry->v_build	= ntohl(veropt->build);
		
		/* read hardware address list */
		notice("[udp] Local Hardware Addresses:\n");
		udp_read_hwaddr_list(udp, (data + sizeof(VER_OPT_INFO)), (data_len - sizeof(VER_OPT_INFO)), ipaddr_entry);
		
	} else {
		notice("SUPER-OLD!\n");
		/* no options */
		ipaddr_entry->options = FURY_IOPT_NONE;
		
	}
	
	/* send reply */
	udp_connect_reply(udp, ipaddr_entry);

}



/*
**	UDP_MAINT - routine maintence
*/
void udp_maint(INTERFACE *udp)
{
	/* set global */
	broadcast.udp = udp;
	
	/* do the keep alive checks */
	hash_enum_entries(&udp->data.u.u_ipaddrs, (void (*)(int, void *))udp_keepalive_check);		
	
	/* move stale IPs */
	hash_remove_multi(&udp->data.u.u_ipaddrs, (int (*)(void *))udp_remove_losers);

}

/*
**	UDP_KEEPALIVE_CHECK
*/
int udp_keepalive_check(int num, IPADDR_ENTRY *entry)
{
	BYTE			buffer[32];
	
	/* compare the last recv'd time for this guy */
	if( (ifg.now.tv_sec - entry->last_recv_time.tv_sec) > FURY_UDP_KEEPALIVE_CHECK ) {
	
		/* now.. have we sent a keepalive anytime soon? */
		if( (ifg.now.tv_sec - entry->last_keepalive.tv_sec) > FURY_UDP_KEEPALIVE_RESEND ) {
		
			if( entry->keepalives_sent < FURY_UDP_KEEPALIVE_MAX ) {
				notice("[udp] Sending keepalive (%d/%d) to %s:%d\n", entry->keepalives_sent + 1, FURY_UDP_KEEPALIVE_MAX, entry->hostname, entry->port);
				/* send another one */
				buffer[0] = 'K';
				
				/* send it */
				udp_sendto(broadcast.udp, entry, buffer, 1);
 						
				/* set the time of the last keepalive */
				memcpy(&entry->last_keepalive, &ifg.now, sizeof(struct timeval));
 					
				/* up the counter */
				entry->keepalives_sent++;
			} else {
 				/* they are dead! -- remove them from the list */
 				entry->removed = 1;
 			}
 		}
 					
 	} else {
 		/* reset counter */
 		entry->keepalives_sent = 0;
 	}
	
	/* done */
	return(1);
}


/*
**	UDP_REMOVE_LOSERS - return true when removed is true.. ?
*/
int udp_remove_losers(IPADDR_ENTRY *entry)
{
	if( entry->removed ) {
		notice("[udp] Removed IP %s:%d\n", entry->hostname, entry->port);
		udp_remove_ip(broadcast.udp, entry);
		return(1);
	} else {
		return(0);
	}
}



/*
**	UDP_SEND_TERM_REQS - counts active IPs and send termination reqs 
*/
void udp_send_term_reqs(int num, IPADDR_ENTRY *entry)
{
	char		buffer[4];
	
	/* is this one not removed? */
	if( entry->removed == 0 ) {
		/* count it */
		active_ips++;
		
		/* send a term req */
		buffer[0] = 'X';
		udp_sendto(broadcast.udp, entry, buffer, 1);
	}
	
	/* done */
	return;	

}



/*
**	UDP_SHOW_OPTIONS
*/
void udp_show_options(int opts)
{

	/* show 'em */
	if( opts & FURY_IOPT_ZLIB ) 
		notice("zlib ");
		
	/* check for no options */
	if( opts == 0x00 )
		notice("None ");
		
	/* final nice'ness */
	notice("\n");
	
	/* done */
	return;
}


/*
**	UDP_CONNECT_REQ - the only way we should start talking with someone
*/
int udp_connect_req(INTERFACE *udp, struct sockaddr_in *to)
{
	BYTE		buffer[512], *dest, *data_end;
	VER_OPT_INFO	*veropt;
	int		len;
	
	/* set ptr */
	veropt = (VER_OPT_INFO *)&buffer[1];
	dest = &buffer[sizeof(VER_OPT_INFO)];
	data_end = buffer + sizeof(buffer);
		
	/* set type */
	buffer[0] = 'C';
	
	/* set version and options */
	veropt->major = htonl(ifg.ver_major);
	veropt->minor = htonl(ifg.ver_minor);
	veropt->build = htonl(ifg.ver_build);
	
	/* set our options */
	veropt->options	= htonl(udp->data.u.u_options);
	
	/* build hwaddr list */
	len = udp_build_hwaddr_list(udp, &buffer[sizeof(VER_OPT_INFO)+1], (511 - sizeof(VER_OPT_INFO)));
	
	/* send it */
	sendto(udp->fd, buffer, 1 + sizeof(VER_OPT_INFO) + len, 0, (struct sockaddr *)to, sizeof(struct sockaddr_in));
	
	/* done */
	return(1);
}

/*
**	UDP_CONNECT_REPLY
*/
int udp_connect_reply(INTERFACE *udp, IPADDR_ENTRY *ipaddr)
{
	char		buffer[256];
	VER_OPT_INFO	*veropt;
	int		len;
	
	/* set ptr */
	veropt = (VER_OPT_INFO *)&buffer[1];
	
	/* build reply */
	buffer[0] = 'c';
	veropt->major = htonl(ifg.ver_major);
	veropt->minor = htonl(ifg.ver_minor);
	veropt->build = htonl(ifg.ver_build);
	veropt->options = htonl(udp->data.u.u_options);
	
	/* add our non-udp hwaddrs to this list */
	len = udp_build_hwaddr_list(udp, &buffer[sizeof(VER_OPT_INFO)+1], 255 - sizeof(VER_OPT_INFO));
	
	/* send it */
	udp_sendto(udp, ipaddr, buffer, 1 + sizeof(VER_OPT_INFO) + len);

	/* did ok */
	return(1);
}



/*
**	UDP_HDRCACHE_MAINT - gets called for every IP in the table
*/
void udp_hdrcache_maint(int num, IPADDR_ENTRY *ip)
{
	/* do the maint */
	hdrcache_maint(&ip->send_hdrcache);
	
	/* done */
	return;

}



/*
**	UDP_WRITE - process our sendbuf
**
**	Note: Do _NOT_ use udp_sendto in this function.. we modify the
**	time variables in here and we don't want udp_sendto to make any changes!
*/
int udp_write(INTERFACE *udp)
{
	IPADDR_ENTRY		**ip;
	BYTE			*data, *ip_data;
	int			data_length, length, ip_length;
	struct sockaddr_in	sin;
	char			buffer[4096];
	int			buf_len;
	char			z_buffer[4096];
	int			z_length;
	
	/* get the buffer contents */
	data_length = 0;
	buffer_get_all(&udp->sendbuf, &data, &data_length);
	
	/* are we quitting? */
	if( udp->options & FOPT_QUITING ) {
		return(0);
	}
	
#if 0
	notice("[udp] %d bytes in my sendbuf\n", data_length);
#endif
	
	/* set the ptr */
	ip = (IPADDR_ENTRY **)data;
	
	/* while there is data */
	length = data_length;
	while( length > 0 ) {

		/* make sure this guy is not NULL */
		if( (*ip) != NULL ) {
			
			/* get length */
			ip_length = buffer_used( (&(*ip)->sendbuf) );
			/* check how much is here and see if it is past the threshold */
			if( (ip_length < udp->data.u.u_buffer_threshold) && (ip_length != 0x00 )  ) {
				
				/* put this ip entry back in the sendbuf */
				buffer_insert(&udp->sendbuf, (BYTE *)ip, sizeof(IPADDR_ENTRY *)); 
				
				/* have they reached the maximum number of process times */
				if( timer_cmp(&((*ip)->buffer_wait), &ifg.now) < 0 ) { 
#if 0
					notice("Holding data.. (%d bytes)\n", ip_length);
#endif					
					/* nope.. so don't do anything and continue looping */
					
					/* move the ip ptr */
					ip++;
					
					/* fix length */
					length -= sizeof(IPADDR_ENTRY *);
					
					/* loop again */
					continue;
				} 
				
				/* they have waited long enough.. send them out */
			}
			
			/* get the buffer contents for this guy */
			buffer_get_all(&(*ip)->sendbuf, &ip_data, &ip_length);		
			
			/* anything to send */
			if( ip_length > 0 ) {
#if SHOW_UDP_WRITE == 1
				notice("Sending data to: %s (%d bytes)\n", (*ip)->hostname, ip_length);
				fprintf(ifg.logfile, "Sending UDP Data:\n");
				fhexdump(ifg.logfile, ip_data, ip_length);
#endif
				/* make the sockaddr struct */
				memset(&sin, 0, sizeof(sin));
				sin.sin_family = AF_INET;
				sin.sin_port = htons((*ip)->port);
				memcpy(&sin.sin_addr, &(*ip)->addr, sizeof(struct in_addr));
				
				/* zlib style - on large packets 	*/
				/* and only if they want it!		*/
				z_length = 0x0FFFFFFF;
				if( ip_length >= FURY_ZLIB_MIN_SIZE ) {
					if( (*ip)->options & FURY_IOPT_ZLIB ) {
						z_length = compress_z(ip_data, ip_length, z_buffer, 4096);
						if( z_length < 0 ) {
							/* problem */
							z_length = 0x0FFFFFFF;
						}
					}
				}
				
				/* did the z-lib help? */
				if( z_length < ip_length ) {
#if 0
					notice("Compressed (zlib) %d -> %d\n", ip_length, z_length);
#endif
					/* send zlib */
					buffer[0] = 'Z';
					memcpy(&buffer[1], z_buffer, z_length);
					buf_len = z_length + 1;
						
				} else {
					/* no compression */
					buffer[0] = 'F';
					memcpy(&buffer[1], ip_data, ip_length);
					buf_len = ip_length + 1;					
				}
				
#if LOG_PACKETS == 1
				fprintf(ifg.logfile, "Sending UDP data to: %s (%d bytes)\n", (*ip)->hostname, buf_len);
				fhexdump(ifg.logfile, buffer, buf_len);
#endif
				/* send it -- dont use udp_sendto.. because we set the time in here */
#if SIMULATE_CRAP == 1
				/* random chance of loss */
				if( (random() % 100) >= PACKET_LOSS_CHANCE ) {
					if( sendto(udp->fd, buffer, buf_len, 0, (struct sockaddr *)&sin, sizeof(sin)) < 0 ) {
						errormsg(0, "udp_write", "sendto failed! %s:%d", (*ip)->hostname, (*ip)->port);
					} 
				} else {
					notice("Dropped Packet\n");
				}
#else
				/* now .. is this IP marked as removed? */
				if( (*ip)->removed == 0 ) {
					if( sendto(udp->fd, buffer, buf_len, 0, (struct sockaddr *)&sin, sizeof(sin)) < 0 ) {
						errormsg(0, "udp_write", "sendto failed! %s:%d", (*ip)->hostname, (*ip)->port);
					}
				}
				
#endif
																	
				/* adjust stats */
				udp->stats.bytes_sent		+= buf_len;
				udp->stats.send_bytes_recent	+= buf_len;
				udp->stats.send_pkt_recent++;
				
				(*ip)->total_sent		+= buf_len;
				
				/* set the last time sent */
				memcpy(&(*ip)->last_sent_time, &ifg.now, sizeof(struct timeval));
				
			} /* data length > 0 */
		} /* (*ip) is non-NULL */
		
		/* move the ptr */
		ip++;
		
		/* dec the length */
		length -= sizeof(IPADDR_ENTRY *);	
	} /* length > 0 */
	
	/* ok */
	return(1);
}

/*
**	UDP_QUEUE_IPX_FRAME - someone wants to send a frame out of us
**
**	We need to save the cache ptrs.. (like stack) because they
** 	will need to be the same when we return...
*/
int udp_queue_ipx_frame(INTERFACE *from, INTERFACE *udp, BYTE *ipxframe)
{
	BYTE		new_fury_frame[FURY_FRAME_MAX];
	int		new_fury_length;
	int		ftype;
	HWIP_ENTRY	*hwip_src, *hwip_dest, hwip_search;
	IPXHEADER	*ipx;
	FURY_CACHE_PTRS	cache_backup;	
	HWADDR_ENTRY	hwaddr_search;
	BUFFER		*old_buf;
	
	/* clean */
	memset(&hwip_search, 0, sizeof(HWIP_ENTRY));
	
	/* save the caches -- and out buf */
	memcpy(&cache_backup, &udp->cache_ptrs, sizeof(FURY_CACHE_PTRS));
	old_buf = udp->outbuf;
	
	/* set ptr */
	ipx = (IPXHEADER *)ipxframe;

	/* we don't care what interface it came from..... maybe 	*/	
	/* it came from the UDP interface.. so make sure we don't send	 */
	/* it to the same IP address.. because it CAME from that network */	
	/* this will only happen on broadcasts and unknown locations	*/
	
	/* get the source.. they might NOT be in our table.. that is ok */
	/* they maybe on another interface.. 				*/
	memcpy(hwip_search.hwaddr, ipx->ipx_src.host, 6);
	hwip_src = hash_get(&udp->data.u.u_hw_to_ip, &hwip_search);
	
	/* get the dest */
	memcpy(hwip_search.hwaddr, ipx->ipx_dest.host, 6);
	hwip_dest = hash_get(&udp->data.u.u_hw_to_ip, &hwip_search);
	
	/* dest could be NULL .. so lets add it */
	if( hwip_dest == NULL ) {
		/* add it in */
		hwip_search.ip = NULL;		/* don't know where they are */
		hwip_dest = hash_insert(&udp->data.u.u_hw_to_ip, &hwip_search);
		if( hwip_dest == NULL ) {
			/* oh well */
			errormsg(0, "udp_q_ipx", "could not add dest to HWIP table!");
			return(0);
		}
	}
		
	/* is this a broadcast? -- problem area */
	if( memcmp(broadcast_addr, hwip_dest->hwaddr, 6) == 0 ) {
		/* do we forward broadcasts? or are they from another interface? */
		if( (udp->options & FOPT_FORWARD) || (from != udp) ) {
#if SHOW_FORWARDING == 1
			notice("[udp] Forwarding broadcast from '%s' (Src: %s)\n", from->name, print_ether_addr(ipx->ipx_src.host));
#endif
			/* fill out the broadcast */
			broadcast.type			= BCAST_TYPE_IPX;
			broadcast.udp			= udp;
			broadcast.data.i.i_ipxframe	= ipxframe;
		
			/* was this from the UDP interface */
			if( from == udp ) {
				/* set the last sender */
				broadcast.sender	= udp->data.u.u_lastrecv;
			} else {
				/* we didn't get it from UDP land */
				broadcast.sender	=  NULL;
			}
			/* do we know the sender? */
			if( hwip_src != NULL )
				broadcast.src	= hwip_src->ip;
			else
				broadcast.src	= NULL;
		
			/* send this to every IP we have */
			hash_enum_entries(&udp->data.u.u_ipaddrs, (void (*)(int, void *))udp_sendto_all);
		} else {
			/* we don't forward broadcasts.. what should we do? */
		}
		
	} else if( hwip_dest->ip != NULL ) {
		/* is this from the UDP interface?  If so, we are	*/
		/* forwarding the packet.. send an IP change packet	*/
		/* to this guy ..					*/
		if( from == udp ) {
			/* send IP change.. to lastrecv */
			udp_send_ip_change(udp, udp->data.u.u_lastrecv, hwip_dest);
			
		} else {
		
			/* send it out! -- just to the dest -- set proper cache ptrs.. */
			udp->outbuf = &hwip_dest->ip->sendbuf;
			memcpy(&udp->cache_ptrs, &hwip_dest->ip->cache_ptrs, sizeof(FURY_CACHE_PTRS));
			
			/* create the frame.. now that we have the proper caches */
			if( create_fury_ipx_frame(udp, ipxframe, new_fury_frame, &ftype, &new_fury_length) ) {
				/* send it */	
				send_fury_frame(udp, ftype, new_fury_frame, new_fury_length);
			
				/* add the ptr to our sendbuf.. */
				buffer_insert(&udp->sendbuf, (BYTE *)&hwip_dest->ip, sizeof(IPADDR_ENTRY *));
			}
		}
	} else {
		/* it is not a broadcast and the destination IP is NULL (unknown)	*/
		/* we need to figure out the IP for this hwaddr				*/
		
		/* have we sent an IP req lately? */
		if( (ifg.now.tv_sec - hwip_dest->last_ip_req_sent.tv_sec) > FURY_IP_REQ_TIMEOUT ) {
			/* lets ask if anyone knows */
			broadcast.type			= BCAST_TYPE_UDP;
			broadcast.udp			= udp;
			broadcast.data.u.u_data		= new_fury_frame;
			broadcast.data.u.u_len		= 7;
			broadcast.sender		= NULL;
			broadcast.src			= NULL;
			
			/* create the buffer req */
			new_fury_frame[0] = 'i';
			
			/* just send the hardware address */
			memcpy(&new_fury_frame[1], hwip_dest->hwaddr, 6);

			/* notice */
			notice("[udp] Requesting IP for %s\n", print_ether_addr(hwip_dest->hwaddr));
			
			/* send it out */
			hash_enum_entries(&udp->data.u.u_ipaddrs, (void (*)(int, void *))udp_sendto_all);
			
			/* set last time */
			memcpy(&hwip_dest->last_ip_req_sent, &ifg.now, sizeof(struct timeval));
			
			/* up the request attempts */
			hwip_dest->ip_req_count++;
			
			/* have we reached the limit */
			if( hwip_dest->ip_req_count > FURY_IP_REQ_MAX ) {
				/* yup.. remove this guy */
				notice("[udp] Removing hwaddr %s\n", print_ether_addr(hwip_dest->hwaddr));
				/* build searches */
				memcpy(&hwip_search, hwip_dest, sizeof(HWIP_ENTRY));
				memcpy(hwaddr_search.hwaddr, hwip_dest->hwaddr, 6);
				/* remove from HW -> IP table */
				if( ! hash_remove(&udp->data.u.u_hw_to_ip, &hwip_search) ) {
					errormsg(0, "udp_q_ipx", "Could not remove from HW -> IP table\n");
				}
				/* now remove from the global list of hardware addresses */
				if( ! hash_remove(&ifg.hwaddr_table, &hwaddr_search) ) {
					errormsg(0, "udp_q_ipx", "Could not remove from global hwaddr table!\n");
				}
			}
		}
	}	

	/* fix the cache ptrs -- and outbuf */
	memcpy(&udp->cache_ptrs, &cache_backup, sizeof(FURY_CACHE_PTRS));
	udp->outbuf = old_buf;
	
	/* ok */
	return(1);
}


/*
**	UDP_SENDTO_ALL - sends this to every IP we know about
*/
void udp_sendto_all(int num, IPADDR_ENTRY *entry)
{
	INTERFACE		*udp;
	int			ftype, length;
	BYTE			new_fury_frame[FURY_FRAME_MAX];
	
	/* what type */
	if( broadcast.type == BCAST_TYPE_IPX ) {
		/* don't send this back to the sender.. conserve bandwidth! 	*/
		/* PLUS it stops infinite loops.. ooohh 			*/
		/* also, don't send something with a src back to the same network */
		if( (broadcast.sender != entry) && (broadcast.src != entry) ) {
			/* set the proper stuff */
			udp 				= broadcast.udp;
			udp->outbuf 			= &entry->sendbuf;
			memcpy(&udp->cache_ptrs, &entry->cache_ptrs, sizeof(FURY_CACHE_PTRS));
			
			/* ok, make the frame.. */
			if( ! create_fury_ipx_frame(udp, broadcast.data.i.i_ipxframe, new_fury_frame, &ftype, &length) ) {
				return;
			}
			
			/* send the frame */
			send_fury_frame(broadcast.udp, ftype, new_fury_frame, length);
		
			/* add this ptr to our outbuf */
			buffer_insert(&broadcast.udp->sendbuf, (BYTE *)&entry, sizeof(IPADDR_ENTRY *));
		}
	} else if( broadcast.type == BCAST_TYPE_UDP ) {
		/* send to all UDP buddies */
		udp_sendto(broadcast.udp, entry, broadcast.data.u.u_data, broadcast.data.u.u_len);
	} else {
		errormsg(0, "sendto_all", "unknow broadcast type!");
	}

}





/*
**	UDP_IPXFRAME_PROCESSOR - after FURY_RECEIVE has reconstructed an IPX frame it calls this..
*/
int udp_ipxframe_processor(INTERFACE *fdev, BYTE *ipxframe)
{
	HWIP_ENTRY		hwip_search, *hwip_entry;
	IPXHEADER		*ipxheader;
	HWADDR_ENTRY		*hwaddr_entry, hwaddr_search;
	char			buffer[32];	
	
	/* clean */
	memset(&hwip_search, 0, sizeof(HWIP_ENTRY));
	memset(&hwaddr_search, 0, sizeof(HWADDR_ENTRY));
		
	/* set the ipx ptr */
	ipxheader = (IPXHEADER *)ipxframe;

	/* look this src hardware address up.. */
	memcpy(hwaddr_search.hwaddr, ipxheader->ipx_src.host, 6);
	hwaddr_entry = hash_get(&ifg.hwaddr_table, &hwaddr_search);
	
	if( hwaddr_entry != NULL ) {
		/* ok.. we have seen this before, make sure it is this interface (udp) */
		if( hwaddr_entry->interface != fdev ) {
			/* problem here! */
			notice("[udp] Received local network data (from %s:%d)\n", fdev->data.u.u_lastrecv->hostname, fdev->data.u.u_lastrecv->port);
			notice("[udp] Src: %s  ", print_ether_addr(ipxheader->ipx_src.host));
			notice("Dest: %s\n", print_ether_addr(ipxheader->ipx_dest.host));
			
			/* need to send something telling them to STOP! */
			buffer[0] = 'L';
			memcpy(&buffer[1], hwaddr_entry->hwaddr, 6);
			udp_sendto(fdev, fdev->data.u.u_lastrecv, buffer, 7);
			return(0);
		}
	}
	
	/* build the search -- copy the ether addr for the source */
	memcpy(hwip_search.hwaddr, ipxheader->ipx_src.host, 6);
	
	/* does it exist? */
	hwip_entry = hash_get(&fdev->data.u.u_hw_to_ip, &hwip_search);
	if( NULL == hwip_entry ) {
		/* if the dest was not broadcast.. set the IP	*/
		/* actually -- set the IP no matter what.. 	*/
		/* they should send IP changes..		*/
		hwip_search.ip = fdev->data.u.u_lastrecv;
				
		/* add it */
		hwip_entry = hash_insert(&fdev->data.u.u_hw_to_ip, &hwip_search);
		if( NULL == hwip_entry ) {
			/* darn! */
			errormsg(0, "udp_ipxframe_proc", "could not add hwaddr to table!");
			return(0);
		}
#if 1
		notice("[udp] Adding mapping: %s <-> %s:%d\n", print_ether_addr(ipxheader->ipx_src.host), fdev->data.u.u_lastrecv->hostname, fdev->data.u.u_lastrecv->port);
#endif		

	} else {
		/* set the source -- might have changed because of bad stuff 	*/
		/* however, don't record it if it was a broadcast..		*/
		
		if( memcmp(broadcast_addr, ipxheader->ipx_dest.host, 6) != 0 ) {
			/* not a broadcast! */
		
#if 1
			if( hwip_entry->ip != fdev->data.u.u_lastrecv ) {
				notice("[udp] IP changed for %s to %s:%d\n", print_ether_addr(ipxheader->ipx_src.host), fdev->data.u.u_lastrecv->hostname, fdev->data.u.u_lastrecv->port);
			}
#endif
			
			/* save it */
			hwip_entry->ip = fdev->data.u.u_lastrecv;
			
		}
	}
		
	/* done */
	return(1);
}


/*
**	UDP_READ - reads data and puts it in the recvbuffer
*/
int udp_read(INTERFACE *udp)
{
	int			bytes_read;
	struct sockaddr_in	from;
	int			fromlen;
	IPADDR_ENTRY		ipaddr_search, *ipaddr_entry;
	HWIP_ENTRY		hwip_search, *hwip_entry;
	char			buffer[8];
	IP_CHANGE		*ip_change;
	char			z_buffer[4096];
	int			z_length;
	HWADDR_ENTRY		hwaddr_search, *hwaddr_entry;
	int			packets_read, bytes_avail;
	
	/* clean */
	memset(&hwip_search, 0x00, sizeof(HWIP_ENTRY));
	packets_read = 0;
	
	/* the loop */
	do { 
		/* read from the the device */
		fromlen = sizeof(from);
		bytes_read = recvfrom(udp->fd, udp_buffer, FURY_UDP_RECV_BUF_SIZE, 0, (struct sockaddr *)&from, &fromlen);
		
		/* error? */
		if( bytes_read <= 0 ) {
			/* oh well */
			return(0);
		}
	
		/* lets look this fool up.. */
		memset(&ipaddr_search, 0, sizeof(IPADDR_ENTRY));
		memcpy(&ipaddr_search.addr, &from.sin_addr, sizeof(struct in_addr));
		ipaddr_search.port = ntohs(from.sin_port);
		ipaddr_entry = hash_get(&udp->data.u.u_ipaddrs, &ipaddr_search);
		
		/* is this a new one? -- only add it if a connect req is coming */
		if( NULL == ipaddr_entry ) {		
			/* is this a connect req? or reply? */
			if( (udp_buffer[0] == 'C') || (udp_buffer[0] == 'c') ) {
				/* add it to the list */
				ipaddr_entry = hash_insert(&udp->data.u.u_ipaddrs, &ipaddr_search);
				if( NULL == ipaddr_entry ) {
					/* damn */
					errormsg(0, "upd_read", "could not add IP address to table!");
					return(0);
				}
				
				/* make the caches */
				if( ! udp_new_ip_entry(udp, ipaddr_entry) ) {
					/* failed */
					errormsg(0, "udp_read", "failed to create buffers/caches!");
					return(0);
				}
			} else {
				/* not a connect req/reply.. so drop it */
				notice("[udp] received data from %s:%d.. but not connected!\n", inet_ntoa(from.sin_addr), ntohs(from.sin_port));
				
				/* send them a '!' */
				udp_buffer[0] = '!';
				sendto(udp->fd, udp_buffer, 1, 0, (struct sockaddr *)&from, sizeof(from));
				
				/* fail */			
				return(0);
			}
		}
		
		/* save this as the last received from */
		udp->data.u.u_lastrecv = ipaddr_entry;
		
		/* set the last recv time */
		memcpy(&ipaddr_entry->last_recv_time, &ifg.now, sizeof(struct timeval));  
			
		/* do something with their data */
		if( bytes_read > 0 ) {		
			/* they are sending us data! */
			
			/* adjust the stats */
			udp->stats.recv_bytes_recent	+= bytes_read;
			udp->stats.bytes_rcvd		+= bytes_read;
			ipaddr_entry->total_recv	+= bytes_read;
			
			/* check the 1st character */
			switch( udp_buffer[0] ) {
				case 'C':
					/* CONNECT */
					udp_accept_connection(udp, &udp_buffer[1], (bytes_read - 1), ipaddr_entry);
					break;
					
				case 'c':
					/* CONNECT reply */
					udp_accept_conreply(udp, &udp_buffer[1], (bytes_read-1), ipaddr_entry);
					break;
									
				case 'I':
					/* IP <-> HWADDR change */
		                        ip_change = (IP_CHANGE *)&udp_buffer[1];
		                        
		                        /* now try to make the change */
       		 	                udp_change_hwip(udp, ip_change);                         
       		 	                break;
       	 	                
       		 	        case 'i':
       		 	        	notice("[udp] IP requested for %s from %s:%d\n", print_ether_addr(&udp_buffer[1]), ipaddr_entry->hostname, ipaddr_entry->port);
       	 		        	/* HWADDR -> IP req -- build the search */
       	 		        	memset(&hwip_search, 0, sizeof(HWIP_ENTRY));
       	 		        	memcpy(hwip_search.hwaddr, &udp_buffer[1], 6);
        		        	
        		        	/* look it up */
        		        	hwip_entry = hash_get(&udp->data.u.u_hw_to_ip, &hwip_search);
        		        	if( hwip_entry == NULL ) {
        		        		/* we don't have it on udp.. but is it local? or on another interface? */
        		        		memset(&hwaddr_search, 0, sizeof(HWADDR_ENTRY));
        		        		memcpy(hwaddr_search.hwaddr, &udp_buffer[1], 6);
        		        		hwaddr_entry = hash_get(&ifg.hwaddr_table, &hwaddr_search);
        		        		if( hwaddr_entry != NULL ) {
        		        			/* make sure it is on another interface! */
        		        			if( (hwaddr_entry->interface != udp) && (hwaddr_entry->interface != NULL) ) {
        		        				/* ok.. send a reply! */
        		        				/* NOTE: addr and port inside of the hwip_search will be 0x00	*/
        		        				/* this means that the address is local to us...		*/
        		        				udp_send_ip_change(udp, udp->data.u.u_lastrecv, &hwip_search);	 
        		        			}
        		        		}        	        		
        		        	} else {
        		        		/* we have an IP for that hwaddr.. send the change */
        		        		if( hwip_entry->ip != NULL ) {
		       	 	        		udp_send_ip_change(udp, udp->data.u.u_lastrecv, hwip_entry);
		       	 	        	}
	       	 	        	}
        		        	break;
        		        	
        	                
				case 'F':        	            
					/* add this data into the receive buffer */
					if( buffer_insert(&udp->recvbuf, &udp_buffer[1], bytes_read-1) ) {
						/* done */
						return(bytes_read);
					} else {
						/* could not insert */
						errormsg(0, "udp_read", "could not insert data into buffer!");
						return(0);
					}
					break;
					
				case 'Z':
					/* zlib compressed fury data */
					z_length = uncompress_z(&udp_buffer[1], bytes_read-1, z_buffer, 4096);
					if( z_length > 0 ) {
						/* insert this into our buffer */
						if( buffer_insert(&udp->recvbuf, z_buffer, z_length) ) {
							/* ok */
							return(z_length);
						} else {
							/* damn */
							errormsg(0, "udp_read", "could not add compressed data (zlib)");
						}
					} else {
						/* error */
						errormsg(0, "udp_read", "Error uncompressing data (zlib)");
					}
					break;
				
	 			case 'K':
					/* send them something back -- keepalive req */
					buffer[0] = 'k';
					udp_sendto(udp, ipaddr_entry, buffer, 1);
					break;
					
				case 'k':
					/* keep alive responce */
					notice("[udp] %s:%d is still alive.\n", ipaddr_entry->hostname, ipaddr_entry->port);
					/* reset keepalive counter */
					ipaddr_entry->keepalives_sent = 0;				
					break;
					
				case 'X':
					/* term req -- send an ack back and mark them removed */
					if( ipaddr_entry->removed == 0 ) 
						notice("[udp] Termination request received from %s:%d!\n", ipaddr_entry->hostname, ipaddr_entry->port);
					buffer[0] = 'x';
					/* temp.. so we send them something */
					ipaddr_entry->removed = 0;
					udp_sendto(udp, ipaddr_entry, buffer, 1);
					/* mark as removed again */
					ipaddr_entry->removed = 1;
					break;
					
				case 'x':
					/* term ack -- remove this IP! */
					if( ipaddr_entry->removed == 0 ) 
						notice("[udp] Termination ACK received from %s:%d\n", ipaddr_entry->hostname, ipaddr_entry->port);
					ipaddr_entry->removed = 1;
					break;
					
				case '!':		/* we aren't really connected */
					notice("[udp] Lost connection to %s:%d.. Try reconnecting!\n", ipaddr_entry->hostname, ipaddr_entry->port);
					/* remove them from the list */
					ipaddr_entry->removed = 1;
					break;
					
				case 'L':		/* we broadcasted something that is local to them */
					/* lookup this hwaddr and hwip */
					memcpy(hwaddr_search.hwaddr, &udp_buffer[1], 6);
					hwaddr_entry = hash_get(&ifg.hwaddr_table, &hwaddr_search);
					if( hwaddr_entry != NULL ) {
						/* set the interface */
						hwaddr_entry->interface = udp;
						/* now create a mapping */
						memcpy(hwip_search.hwaddr, &udp_buffer[1], 6);
						hwip_entry = hash_get(&udp->data.u.u_hw_to_ip, &hwip_search);
						if( hwip_entry != NULL ) {
							/* notice */
							if( hwip_entry->ip != ipaddr_entry )
								notice("[udp] Set IP for %s to %s:%d\n", print_ether_addr(&udp_buffer[1]), ipaddr_entry->hostname, ipaddr_entry->port);
								
							/* set the mapping */
							hwip_entry->ip = ipaddr_entry;
						}
					}
					break;
				default:
					/* show some info */
					notice("Unknown UDP Packet Type (0x%.2x) from %s:%d\n", udp_buffer[0], ipaddr_entry->hostname, ipaddr_entry->port);
					hexdump(udp_buffer, bytes_read);
					break;
			}
		} 
		
		/* now process.. */
		udp_process(udp);
		
		/* we did a read.. */
		packets_read++;
		
		/* is there more? */
		if( ioctl(udp->fd, FIONREAD, &bytes_avail) < 0 ) {
			bytes_avail = 0;
		} else {
#if 0
			notice("[udp] %d more bytes avail\n", bytes_avail);
#endif
		}
		
	} while( (bytes_avail > 0) && (packets_read < FURY_UDP_READ_PACK_MAX) );
	
	/* nothing to do */
	return(packets_read);
}



/*
**	UDP_PROCESS - process our recv buffer (called right after read)
*/
int udp_process(INTERFACE *udp)
{
	BYTE		*data;
	int		length;
	int		previous_len;
		
	/* init */
	length = 0;
	
	/* get all the data in the buffer */
	buffer_get_all(&udp->recvbuf, &data, &length);
	
	/* is there something to process? */
	if( length > 0 ) {

		/* since UDP is reliable data, we don't need a beginning 0x7D */
		udp->frames_sent		= 1;
	
		/* set the proper outbuffer .. since we might need to send stuff */
		udp->outbuf 			= &udp->data.u.u_lastrecv->sendbuf;
		memcpy(&udp->cache_ptrs, &udp->data.u.u_lastrecv->cache_ptrs, sizeof(FURY_CACHE_PTRS));
		
		/* get previous len */
		previous_len = buffer_used(udp->outbuf);
		
		/* now process the data */
		fury_receive(udp, data, length);
		
		/* is there something in the outbuf now? */
		if( buffer_dirty(udp->outbuf) ) {
			/* was there buffer empty? */
			if( previous_len == 0x00 ) {
				/* set buffer wait time */
				memcpy(&udp->data.u.u_lastrecv->buffer_wait, &ifg.now, sizeof(struct timeval));
				timer_add(&udp->data.u.u_lastrecv->buffer_wait, udp->data.u.u_buffer_wait_sec, udp->data.u.u_buffer_wait_usec);
			}
			/* add them to our outgoing list */
			buffer_insert(&udp->sendbuf, (BYTE *)&udp->data.u.u_lastrecv, sizeof(IPADDR_ENTRY *));
		}
	}
	
	/* are we quitting? */
	if( udp->options & FOPT_QUITING ) {
		if( udp->state != FURY_STATE_CLOSED ) {
			/* get active IP's -- and send term reqs -- set broadcast.udp */
			active_ips = 0;
			broadcast.udp = udp;
			hash_enum_entries(&udp->data.u.u_ipaddrs, (void (*)(int, void *))udp_send_term_reqs);
				
			/* are we done */
			if( active_ips == 0 ) {
				/* no one left! */
				udp->state = FURY_STATE_CLOSED;
				notice("[%6s] Closed.\n", udp->name);
			} else if ( (udp->exit_time.tv_sec - ifg.now.tv_sec) <= 0 ) {
				/* forced exit */
				notice("[%6s] Unable to terminate all conections (%d left) .. exiting\n", udp->name, active_ips);
				udp->state = FURY_STATE_CLOSED;
			}
		
		}
	}
	
	/* ok */
	return(1);
}


/*
**	UDP_DUMMY - placeholder
*/
int udp_dummy(INTERFACE *udp)
{
	/* always ok */
	return(1);
}


/*
**	UDP_OPEN - gets a udp socket (this gets called at the very start!)
*/
int udp_open(INTERFACE *udp)
{
	int			socketfd;
	struct protoent		*proto;
	struct sockaddr_in	sin;
	HWIP_ENTRY		hwip_new;
	
	/* clean */
	memset(&hwip_new, 0x00, sizeof(HWIP_ENTRY));
		
	/* get udp protocol */
	proto = getprotobyname("udp");
	if( NULL == proto ) {
		errormsg(0, "udp_open", "could not get udp protocol number!");
		return(0);
	}
	
	/* ok, get our socket */
	socketfd = socket(AF_INET, SOCK_DGRAM, proto->p_proto);
	if( socketfd == -1 ) {
		errormsg(0, "udp_open", "could not get a socket!");
		return(0);
	}
	
	/* build the sockaddr struct */
	memset(&sin, 0, sizeof(sin));
	sin.sin_family		= AF_INET;
	sin.sin_port		= htons(udp->data.u.u_portnumber);
	sin.sin_addr.s_addr	= INADDR_ANY;
	
	/* bind it */
	if( bind(socketfd, (struct sockaddr *)&sin, sizeof(sin)) < 0 ) {
		errormsg(0, "udp_open", "could not bind the socket");
		close(socketfd);
		return(0);
	}
	
	/* create buffers */
	if( ! create_buffer(&udp->recvbuf, FURY_UDP_RECV_BUF_SIZE) ) {
		close(socketfd);
		return(0);
	}
	if( ! create_buffer(&udp->sendbuf, FURY_UDP_TRANS_BUF_SIZE) ) {
		close(socketfd);
		return(0);
	}
	
	/* no outbuf -- it is IP address dependant */
	udp->outbuf = NULL;
	
	/* create our IP address hash table */
	if( ! create_hash_table(&udp->data.u.u_ipaddrs,
				FURY_IPADDR_TABLE_SIZE,
				sizeof(IPADDR_ENTRY),
				(int (*)(void *))ipaddr_hash,
				(int (*)(void *, void *))ipaddr_compare) ) {
		close(socketfd);
		return(0);
	}
	
	/* create our hardware address to IP hash table */
	if( ! create_hash_table(&udp->data.u.u_hw_to_ip,
				FURY_HWIP_TABLE_SIZE,
				sizeof(HWIP_ENTRY),
				(int (*)(void *))hwip_hash,
				(int (*)(void *, void *))hwip_compare) ) {
		close(socketfd);
		return(0);
	}
	
	/* add in the broadcast address */
	memset(hwip_new.hwaddr, 0xFF, 6);
	hwip_new.ip = NULL;
	if( NULL == hash_insert(&udp->data.u.u_hw_to_ip, &hwip_new) ) {
		/* damn */
		errormsg(0, "udp_open", "could not add broadcast address to HWIP table!");
		return(0);
	}
	

	/* don't drop.. */
	memset(&udp->furyframe, 0, sizeof(FURYFRAME));
	udp->furyframe.drop = 0;
	
	/* clear caches! */
	memset(&udp->cache_ptrs, 0, sizeof(FURY_CACHE_PTRS));
	
	/* so far, so good */
	udp->flags |= FURY_IF_VALID;
	udp->state = FURY_STATE_INITIAL;
	
	/* recent stats starting time */
	gettimeofday(&udp->stats.recent_stats_start, NULL);
	
	/* set our options */
	udp->data.u.u_options = FURY_IOPT_NONE;
#ifdef USE_ZLIB
	udp->data.u.u_options |= FURY_IOPT_ZLIB;
#endif

	/* ok, save this */
	udp->fd	= socketfd;
	
	/* little notice */
#if SIMULATE_CRAP == 1
	notice("[udp] simulating bad network (%d%% chance of packet loss)\n", PACKET_LOSS_CHANCE);
#endif 
	
	/* ok, we are done */
	return(1);

}


/*
**	UDP_CLOSE - ends our fun time
*/
int udp_close(INTERFACE *udp)
{

	/* is this a valid interface? */
	if( (udp->flags & FURY_IF_VALID) != FURY_IF_VALID ) {
		errormsg(0, "udp_close", "called with non-valid interface!");
		return(0);
	}
	
	/* free the buffers */
	free_buffer(&udp->sendbuf);
	free_buffer(&udp->recvbuf);
	
	/* close the file descriptor */
	close(udp->fd);
	
	/* no longer valid */
	udp->fd = -1;
	
	/* set the flags */
	udp->flags &= ~FURY_IF_VALID;
	
	/* done */
	return(1);
}


/*
**	UDP_EVENT - the event handler
*/
int udp_event(INTERFACE *udp, int event)
{

	/* just change the state */
	switch( event ) {
		case FURY_EVENT_UP:
		case FURY_EVENT_OPEN:
			udp->options &= ~FOPT_QUITING;
			udp->state = FURY_STATE_OPENED;
			break;
			
		case FURY_EVENT_DOWN:
		case FURY_EVENT_CLOSE:
			udp->options |= FOPT_QUITING;
			memcpy(&udp->exit_time, &ifg.now, sizeof(struct timeval));
			/* add exit time.. */
			udp->exit_time.tv_sec += FURY_UDP_EXIT_WAIT;
			/* message */
			notice("[udp] Sending Termination REQ to all IPs (max wait: %d secs)\n", FURY_UDP_EXIT_WAIT);
			break;
	}
	
	/* ok */
	return(1);
}


/*
**	UDP_PREPARE - 
*/
int udp_prepare_device(INTERFACE *udp)
{
	/* put it into the open state */
	udp->state = FURY_STATE_OPENED;
	
	/* ok */
	return(1);

}


/*
**	UDP_DUMP_HWTABLE - shows the hardware to ip mappping
*/
void udp_dump_hwtable(int num, HWIP_ENTRY *entry)
{
	
	notice("[%2d] %s", num, print_ether_addr(entry->hwaddr));	
	/* do we know? */
	if( entry->ip != NULL ) {
		notice("   %s:%d\n", entry->ip->hostname, entry->ip->port);
	} else {
		notice("   Broadcast\n");
	}

}


/*
**	UDP_DUMP_IPTABLE - lists all those ips
*/
void udp_dump_iptable(int num, IPADDR_ENTRY *entry)
{
	char		buffer[128];
	
/*               [..] 12345678901234567890 (111.222.333.444) 12345 */
	sprintf(buffer, "%d.%d.%d", entry->v_major, entry->v_minor, entry->v_build);
	notice("[%2d] %-15s %-5d %-25s %-9s", num, inet_ntoa(entry->addr), entry->port, entry->hostname, buffer);

	notice(" %-7s", print_datatrans(entry->total_sent));
	notice(" %s\n", print_datatrans(entry->total_recv));
	
	/* done */
	return;

}


/*
**	UDP_SEND_IP_CHANGE - sends a peer an IP change (responce)
*/
void udp_send_ip_change(INTERFACE *udp, IPADDR_ENTRY *to, HWIP_ENTRY *hwip)
{
	BYTE			buffer[sizeof(IP_CHANGE) + 1];
	IP_CHANGE		*change;
	
	/* have we done one recently? */
	if( (ifg.now.tv_sec - hwip->last_ip_change_sent.tv_sec) < FURY_IP_CHANGE_TIMEOUT ) {
		/* yup.. just return */
		return;
	}
	
	/* set the last sent time */
	memcpy(&hwip->last_ip_change_sent, &ifg.now, sizeof(struct timeval));
	
	/* msg */
	notice("[udp] Sending IP change to %s:%d for %s\n", to->hostname, to->port, print_ether_addr(hwip->hwaddr));
		
	/* make sure the args are valid */
	if( (to == NULL) || (hwip == NULL) ) {
		/* doh */
		errormsg(0, "udp_change_ip", "to and/or hwip are NULL!");
		return;
	}
	
	/* build packet */
	buffer[0] = 'I';
	change = (IP_CHANGE *)&buffer[1];
	/* if the ip part is NULL, it is from us! */
	if( hwip->ip == NULL ) {
		notice("[udp] hwaddr is local.. sending our IP\n");
		change->addr.s_addr	= 0x0;
		change->port		= 0x0;
	} else {
		notice("[udp] hwaddr is at %s:%d... tell them to go ask\n", hwip->ip->hostname, hwip->ip->port);
		change->addr.s_addr	= hwip->ip->addr.s_addr;
		change->port		= htons(hwip->ip->port);
	}
	memcpy(change->hwaddr, hwip->hwaddr, 6);

	/* ok send it */
	udp_sendto(udp, to, buffer, sizeof(IP_CHANGE)+1);
	
	/* done */
	return;
}

/*
**	UDP_CHANGE_HWIP - changes a HWIP entry.. we get these from peers
*/
int udp_change_hwip(INTERFACE *udp, IP_CHANGE *change)
{
	HWIP_ENTRY		hwip_search, *hwip_entry;
	IPADDR_ENTRY		ipaddr_search, *ipaddr_entry;
	struct sockaddr_in	sin;
	char			buffer[32];

	/* is the address 0x00 - meaning it is local to lastrecv	*/
	/* so we can trust it!						*/
	if( change->addr.s_addr == 0x00 ) {
		/* fix the change struct */
		memcpy(&change->addr, &udp->data.u.u_lastrecv->addr, sizeof(struct in_addr));
 		change->port = udp->data.u.u_lastrecv->port;
	
		/* lookup the hardware address */
		memcpy(&hwip_search.hwaddr, change->hwaddr, 6);
		hwip_entry = hash_get(&udp->data.u.u_hw_to_ip, &hwip_search);
		
		/* do we have one? -- need to fix this */
		if( hwip_entry == NULL ) {
			/* this is complicated.... and shouldn't happen */
			errormsg(0, "udp_change_hwip", "no HWIP entry!");
			return(0);
		}
	
		/* ok, we have the ptr.. now look up the IP */
		memset(&ipaddr_search, 0, sizeof(IPADDR_ENTRY));
		memcpy(&ipaddr_search.addr, &change->addr, sizeof(struct in_addr));
		ipaddr_search.port = change->port;
		ipaddr_entry = hash_get(&udp->data.u.u_ipaddrs, &ipaddr_search);
	
		/* is this person new to us? */
		if( ipaddr_entry == NULL ) {
			/* build sin */
			memset(&sin, 0, sizeof(sin));
			sin.sin_family	= AF_INET;
			sin.sin_port	= htons(change->port);
			memcpy(&sin.sin_addr, &change->addr, sizeof(struct in_addr));
			
			/* send a connect req! */
			notice("[udp] Not connected.. send connect req!\n");
			udp_connect_req(udp, &sin);
			
		} else {
			/* show a message if the IP changed */
			if( hwip_entry->ip != ipaddr_entry ) {
		                notice("[udp] received IP change: %s <-> %s:%d\n", print_ether_addr(change->hwaddr), inet_ntoa(change->addr), ntohs(change->port));
			}
			/* now change the IP addr in the HWIP */
			hwip_entry->ip = ipaddr_entry;
		}
		
	} else {
		/* go check with the address in addr */
		/* ok, we have the ptr.. now look up the IP */
		memset(&ipaddr_search, 0, sizeof(IPADDR_ENTRY));
		memcpy(&ipaddr_search.addr, &change->addr, sizeof(struct in_addr));
		ipaddr_search.port = ntohs(change->port);
		ipaddr_entry = hash_get(&udp->data.u.u_ipaddrs, &ipaddr_search);
	
		/* is this person new to us? */
		if( ipaddr_entry == NULL ) {
			/* build sin */
			memset(&sin, 0, sizeof(sin));
			sin.sin_family	= AF_INET;
			sin.sin_port	= change->port;
			memcpy(&sin.sin_addr, &change->addr, sizeof(struct in_addr));
			
			/* send a connect req! */
			notice("[udp] Not connected.. send connect req!\n");
			udp_connect_req(udp, &sin);
			
		} else {
		
			/* ok.. now send the REQ to them */
			buffer[0] = 'i';
			memcpy(&buffer[1], change->hwaddr, 6);
		
			/* send it */
			udp_sendto(udp, ipaddr_entry, buffer, 7);
		}
		
	}
	
	/* done */
	return(1);


}


/*
**	UDP_NEW_IP_ENTRY - creates all the caches/buffers
*/
int udp_new_ip_entry(INTERFACE *udp, IPADDR_ENTRY *ipaddr_entry)
{
		
	/* create an outgoing buffer for them */
	if( ! create_buffer(&ipaddr_entry->sendbuf, FURY_IP_SEND_BUF_SIZE) ) {
		/* darn */
		errormsg(0, "udp_new_ip", "could not create send buffer!");
		return(0);
	}
	
	/* make the caches.. */
	if( ! create_hdrcache(&ipaddr_entry->send_hdrcache, HDRCACHE_DEFAULT_SIZE) ) {
		errormsg(0, "udp_new_ip", "could not make send hdrcache!");
		return(0);
	}
	if( ! create_hdrcache(&ipaddr_entry->recv_hdrcache, HDRCACHE_DEFAULT_SIZE) ) {
		errormsg(0, "udp_new_ip", "could not make recv hdrcache!");
		return(0);
	}
	
	/* create the pkt caches */
	if( ! create_hash_table(&ipaddr_entry->send_pktcache,
				FURY_PKTCACHE_TABLE_SIZE,
				sizeof(PKTCACHE_ENTRY),
				(int (*)(void *))pktcache_hash,
				(int (*)(void *, void *))pktcache_compare) ) {
		errormsg(0, "udp_new_ip", "could not create send pkt cache!");
		return(0);
	}
	if( ! create_hash_table(&ipaddr_entry->recv_pktcache,
				FURY_PKTCACHE_TABLE_SIZE,
				sizeof(PKTCACHE_ENTRY),
				(int (*)(void *))pktcache_hash,
				(int (*)(void *, void *))pktcache_compare) ) {
		errormsg(0, "udp_new_ip", "could not create recv pkt cache!");
		return(0);
	}
	
	/* send and recv time */
	memset(&ipaddr_entry->last_sent_time, 0, sizeof(struct timeval));
	memset(&ipaddr_entry->last_recv_time, 0, sizeof(struct timeval));
	
	/* set keepalives */
	ipaddr_entry->keepalives_sent = 0;
	memset(&ipaddr_entry->last_keepalive, 0, sizeof(struct timeval));	
	
	/* no diff yet */
	ipaddr_entry->diff_reset	= 0;
	ipaddr_entry->last_sendsize	= -1;
	ipaddr_entry->last_recvsize	= -1;
	
	/* build cache ptrs.. ugh */
	ipaddr_entry->cache_ptrs.send_hdrcache	= &ipaddr_entry->send_hdrcache;
	ipaddr_entry->cache_ptrs.recv_hdrcache	= &ipaddr_entry->recv_hdrcache;
	ipaddr_entry->cache_ptrs.send_pktcache = &ipaddr_entry->send_pktcache;
	ipaddr_entry->cache_ptrs.recv_pktcache	= &ipaddr_entry->recv_pktcache;
	ipaddr_entry->cache_ptrs.last_senddata	= ipaddr_entry->last_senddata;
	ipaddr_entry->cache_ptrs.last_sendsize	= &ipaddr_entry->last_sendsize;
	ipaddr_entry->cache_ptrs.last_recvdata	= ipaddr_entry->last_recvdata;
	ipaddr_entry->cache_ptrs.last_recvsize	= &ipaddr_entry->last_recvsize;
	ipaddr_entry->cache_ptrs.diff_reset	= &ipaddr_entry->diff_reset;	
	
	/* no options */
	ipaddr_entry->options 	= FURY_IOPT_NONE;
	
	/* don't remove this */
	ipaddr_entry->removed	= 0;
	
	/* lookup their hostname */
	udp_lookup_host(ipaddr_entry);
	
	/* ok */
	return(1);

}

/*
**	UDP_REMOVE_IP - 
*/
int udp_remove_ip(INTERFACE *udp, IPADDR_ENTRY *entry)
{
	/* 1st.. remove any hwaddrs that map to this IP */
	/* and remove the hwaddr from the table		*/
	broadcast.src = entry;
	hash_remove_multi(&udp->data.u.u_hw_to_ip, (int (*)(void *))udp_remove_mappings);
	
	/* next free the buffers/caches */
	free_buffer(&entry->sendbuf);
	free_hdrcache(&entry->send_hdrcache);
	free_hdrcache(&entry->recv_hdrcache);
	free_hash_table(&entry->send_pktcache);
	free_hash_table(&entry->recv_pktcache);
	
	/* did ok */
	return(1);

}

/*
**	UDP_REMOVE_MAPPINGS - remove the hardware address
*/
int udp_remove_mappings(HWIP_ENTRY *entry)
{
	HWADDR_ENTRY	hwaddr_search;
	
	/* do we want to remove this one? -- using bcast.src as a holder */
	if( entry->ip == broadcast.src ) {
		/* yup.. this has to go */
		
		/* remove the hwaddr from the big table */
		memcpy(hwaddr_search.hwaddr, entry->hwaddr, 6);
		hash_remove(&ifg.hwaddr_table, &hwaddr_search);
		
		/* now remove this guy */
		return(1);
	}
	
	/* this entry is safe */
	return(0);
}

/*
**	UDP_SENDTO - just to make sure we set the last time
*/
int udp_sendto(INTERFACE *udp, IPADDR_ENTRY *ip, void *buffer, int len)
{
	struct sockaddr_in	sin;

	/* are they removed? */
	if( ip->removed == 1 ) {
		return(0);
	}
	
	/* make sin */
	memset(&sin, 0, sizeof(sin));
	sin.sin_family 		= AF_INET;
	sin.sin_port		= htons(ip->port);
	sin.sin_addr.s_addr	= ip->addr.s_addr;
	
	/* set the time */
	memcpy(&ip->last_sent_time, &ifg.now, sizeof(struct timeval));
	
	/* up the count */
	ip->total_sent += len;
	
	/* ok, send it */
#if SIMULATE_CRAP == 1
	if( (random() % 100) >= PACKET_LOSS_CHANCE ) {
		/* send it */
		return( sendto(udp->fd, buffer, len, 0, (struct sockaddr *)&sin, sizeof(sin)) );
	} else {
		notice("Dropped Packet.\n");
		return(0);
	}
#else
	/* always send it */
	return( sendto(udp->fd, buffer, len, 0, (struct sockaddr *)&sin, sizeof(sin)) );
#endif


}

